function [x,p]=gcblss(A,b,p) 
% customized blss for acgc. 
% To solve: Ax-lam<x>=b 
% With <u>=eta*u write (A-lam*nu eta)x=b; 
% and solve by Sherman-Morrison 
% eta=[eta 0] for bordered system 
global lam eta nu; % lam set in acgcG
enu=[nu; 0]; eeta=[eta 0];
y=A\b; z=A\enu; al0=lam*eeta*z; al=lam*eeta*y/(1-al0); x=y+al*z; 
return % comment out to check Sherman 
c1=(A-lam*nu*eta)*x; c2=(A-lam*nu*eta)*y; 
err1=norm(c1-b); err2=norm(c2-b); 
fprintf('blss: SM-err=%g, noSM-err=%g\n', err1,err2);  
