function J=afj1(p,u)
% jacobian of nondimensional AgroForestry model with NO light competition
b1=u(1); b2=u(2); w1=u(3); w2=u(4); 
par=u(5:end); 
% Loading to parameters names
p=par(1); lamb1=par(2);eta1=par(3);gam1=par(4);rho1=par(6);
lamb2=par(7);eta2=par(8);gam2=par(9);mu2=par(10);rho2=par(11);
nu=par(12);kappa=par(13);zeta=par(14);
br=par(15);
zv=zeros(size(b1)); 
% Comp version2 Jacobian
f1b1= lamb1*w1.*(b1./((b2.^4)./(b2.^4 + br^4)-1)+1).*(1+eta1*b1).^2+(lamb1*b1.*w1.*(1+eta1*b1).^2)./((b2.^4)./(b2.^4+br^4)-1)+2*eta1*lamb1*b1.*w1.*(b1./((b2.^4)./(b2.^4+br^4)-1)+1).*(1+eta1*b1)-1;
f1b2= -(lamb1*(b1.^2).*w1.*((4*b2.^3)./(b2.^4+br^4)-(4*b2.^7)./(b2.^4+br^4).^2).*(1+eta1*b1).^2)./(b2.^4./(b2.^4+br^4)-1).^2;
f1w1= lamb1*b1.*(b1./((b2.^4)./(b2.^4 + br^4)-1)+1).*(1+eta1*b1).^2;
f1w2= zv;
f2b1= zv;
f2b2= -mu2-lamb2*b2.*w2.*((1+eta2*b2).^2)+lamb2*w2.*((1+eta2*b2).^2).*(1-b2)+2*lamb2*eta2*b2.*w2.*(1+eta2*b2).*(1-b2);
f2w1= zv;
f2w2= lamb2*b2.*((1+eta2*b2).^2).*(1-b2);
f3b1= (nu*rho1*w1)./((1+rho1*b1+rho2*b2).^2)-gam1*w1.*((1+eta1*b1).^2)-2*eta1*gam1*b1.*w1.*(1+eta1*b1);
f3b2= (nu*rho2*w1)./((1+rho1*b1+rho2*b2).^2);
f3w1= -2*kappa*w1-nu./(1+rho1*b1+rho2*b2)-gam1*b1.*((1+eta1*b1).^2);
f3w2= zv;
f4b1= zv;
f4b2= -gam2*w2.*((1+eta2*b2).^2)-2*eta2*gam2*b2.*w2.*(1+eta2*b2);
f4w1= 2*kappa*zeta*w1;
f4w2= -gam2*b2.*((1+eta2*b2).^2)-2*kappa*zeta*w2;
J=[[f1b1 f1b2 f1w1 f1w2];
   [f2b1 f2b2 f2w1 f2w2];
   [f3b1 f3b2 f3w1 f3w2];
   [f4b1 f4b2 f4w1 f4w2]];
end