%
% XINORM: compute the weighted arclength-continuation xi-norm of z
%
%  xin=xinorm(p,z)
%  z=given vector, xi=value of xi, nq=number of aux. eqn., xiq=weight for aux. eqn.
function xin=mxinorm(p,z)
xi=p.sol.xi; nq=p.nc.nq; xiq=p.sol.xiq; len=length(z);
ul2=norm(z(1:len-1-nq)); q=norm(z(len-nq:len-1)); lamd=z(len); 
if p.sw.mnorm==1; xi=p.sol.mxi; xiq=p.sol.mxiq; end    
    xin=sqrt(xi*ul2^2+xiq*q^2+(1-(xi+xiq)/2)*lamd^2);